$MODID51
$IC(MACROS51)

             SELECT     KEY             ; SELECTS THE KEYPAD
             MOV        R1,#44H         ; 44H, 45H, 46H AND 47H ARE SEGMENT MEMORIES
             MOV        R2,#4           ; GETTING 4 KEYS
             MOV        DPTR,#200H      ; LOAD DATA POINTER

L1:          IFKBHIT
             JNC        L1              ; WAIT UNTIL A KEY IS PRESSED

             GETSCAN    A               ; GET SCANCOD OF THE KEY PRESSED AND STORE IN A
             MOVMEM     A,@A+DPTR
             MOV        @R1,A

L2:          IFKBHIT                    ; THE BOUNCE PROBLEM !
             JC         L2

             INC        R1
             DJNZ       R2,L1

            SETCTRL     0
            SETCTRL     1
            SETCTRL     2
            SETCTRL     3
            
             SELECT     SEG
AGAIN:       ACALL      REFRESH7SEG
             SJMP       AGAIN

REFRESH7SEG:
            CLRCTRL     3
            MOV         A,SG1
            MOV         DAT,A
            DELAY       10
            SETCTRL     3

            CLRCTRL     2
            MOV         A,SG2
            MOV         DAT,A
            DELAY       10
            SETCTRL     2

            CLRCTRL      1
            MOV          A,SG3
            MOV          DAT,A
            DELAY        10
            SETCTRL      1

            CLRCTRL      0
            MOV          A,SG4
            MOV          DAT,A
            DELAY        10
            SETCTRL      0
            RET
ORG 200H
TABLE1: DB  3FH, 30H, 6DH, 79H, 72H, 5BH, 5FH, 31H, 7FH, 7BH
END

